﻿using System;
using System.Windows.Data;
using System.Windows.Media;

namespace DataBindingMainApp.DataConversion
{
  class AmountToBonusBrushConverter : IValueConverter
  {
    public decimal BonusGoal { get; set; }
    public Brush BonusBrush { get; set; }
    public Brush DefaultBrush { get; set; }

    public object Convert(object value, Type targetType,
      object parameter, System.Globalization.CultureInfo culture)
    {
      // the value param contains the original value
      // targetType specifies the type
      // data target binding that the current

      Decimal saleAmount = (Decimal)value;
      if (saleAmount > BonusGoal)
      {
        return BonusBrush;
      }

      return DefaultBrush;
    }

    public object ConvertBack(object value, Type targetType,
        object parameter, System.Globalization.CultureInfo culture)
    {
      // not implemented
      throw new NotImplementedException("not implemented");
    }
  }
}
