﻿using System;

namespace Databinding.Local.DataSources {
  class EmployeeWithValidation {
    private string _firstName;
    public string FirstName {
      get {
        return _firstName;
      }
      set {
        if (String.IsNullOrEmpty(value))
        {
          throw new ArgumentOutOfRangeException("This message for non WPF clients");
        }
        else
        {
          _firstName = value;
        }
      }
    }
    private string _lastName;
    public string LastName {
      get {
        return _lastName;
      }
      set {
        if (String.IsNullOrEmpty(value))
        {
          throw new ArgumentOutOfRangeException("Last Name cannot be an empty string.");

        }
        else
        {
          _lastName = value;
        }
      }
    }
    private decimal _salary;
    public decimal Salary {
      get {
        return _salary;

      }
      set {
        if (value < 0)
        {

          throw new ArgumentOutOfRangeException("Salary cannot be a negative number.");

        }
        else
        {
          _salary = value;
        }
      }
    }

  }
}
