﻿using System;
using System.Collections.Generic;
using System.ComponentModel;

namespace Databinding.Local.DataSources {
  class EmployeeWithValidation2 : IDataErrorInfo {
    Dictionary<string, string> _errorDetails = new Dictionary<string, string>();
    private string _errorString = string.Empty;
    private string _firstName;
    public string FirstName {
      get {
        return _firstName;
      }
      set {
        if (String.IsNullOrEmpty(value))
        {
          _errorDetails["FirstName"] = "You must provide a FirstName for the Employee.";
          _errorString = "Errors in Employee class.";
        }
        else
        {
          _firstName = value;
          _errorDetails["FirstName"] = "";
          _errorString = "";
        }
      }
    }
    private string _lastName;
    public string LastName {
      get {
        return _lastName;
      }
      set {
        if (String.IsNullOrEmpty(value))
        {
          _errorDetails["LastName"] = "You must provide a LastName for the Employee.";
          _errorString = "Errors in Employee class.";

        }
        else
        {
          _lastName = value;
          _errorDetails["LastName"] = "";
          _errorString = "";
        }
      }
    }
    private decimal _salary;
    public decimal Salary {
      get {
        return _salary;

      }
      set {
        if (value < 0)
        {

          _errorDetails["Salary"] = "Salary cannot be less than zero.";
          _errorString = "Errors in Employee class.";

        }
        else
        {
          _salary = value;
          _errorDetails["Salary"] = "";
          _errorString = "";
        }
      }
    }

    string IDataErrorInfo.Error {
      get {
        return _errorString;
      }
    }
    string IDataErrorInfo.this[string propertyName] {
      get {
        return (string)_errorDetails[propertyName];
      }
    }
  }
}
