﻿using System;
using System.Reflection;
using System.Windows;
using System.Windows.Input;
using System.Xml;

namespace DataBindingMainApp {

  public partial class MainWindow : Window {
    public MainWindow() {
      InitializeComponent();
      this.Loaded += Window1_Loaded;
      this.DemoTree.MouseUp += new MouseButtonEventHandler(This_MouseUp);

    }

    void Window1_Loaded(object sender, RoutedEventArgs e) {
      var xe = DemoTree.Items[0] as XmlElement;
      var xeMenu = xe.ChildNodes[0] as XmlElement;

      Page = new Uri(xeMenu.GetAttribute("page"), UriKind.RelativeOrAbsolute);
      OpenPage();
    }

    void This_MouseUp(object sender, MouseButtonEventArgs e) {
      var xe = DemoTree.SelectedItem as XmlElement;
      if (xe.Name != "demo")
      {
        return;

      }
      Page = new Uri(xe.GetAttribute("page"), UriKind.RelativeOrAbsolute);
      OpenPage();

    }

    public void OpenPage() {
      var folder = System.IO.Path.GetDirectoryName(Assembly.GetEntryAssembly().Location);
      string file = folder + @"\" + Page;
      if (System.IO.File.Exists(file))
      {

        ContentFrame.Source = Page;

      }
      else
      {
        MessageBox.Show("Page not available.");
      }
    }

    #region Properties
    // Using a DependencyProperty as the backing store
    // for PageProperty.
    // This enables animation, styling, binding, etc...
    public static readonly DependencyProperty PageProperty =
        DependencyProperty.Register("Page", typeof(Uri), typeof(MainWindow));

    public Uri Page {
      get { return (Uri)GetValue(PageProperty); }
      set { SetValue(PageProperty, value); }
    }
    #endregion
  }
}
