﻿using System;
using System.ComponentModel;
using System.Windows.Threading;
namespace Databinding.Notification {
  public class InventoryTickerB : INotifyPropertyChanged {
    // change notification via the INotifyPropertyChanged interface

    public event PropertyChangedEventHandler PropertyChanged;

    private string _productName;
    public string ProductName {
      get { return _productName; }
      set {
        _productName = value;
        RaiseNotifyChanged("ProductName");
      }
    }
    private int _unitsInStock;
    public int UnitsInStock {
      get { return _unitsInStock; }
      set {
        _unitsInStock = value;
        RaiseNotifyChanged("UnitsInStock");
      }
    }
    private void RaiseNotifyChanged(string propName) {
      if (PropertyChanged != null)
        PropertyChanged(this, new PropertyChangedEventArgs(propName));
    }

    DispatcherTimer dispTime = new DispatcherTimer();
    static Random ran = new Random();
    public InventoryTickerB() {
      dispTime.Interval = new TimeSpan(0, 0, 0, 0, ran.Next(20, 1500));
      dispTime.Tick += dispTime_Tick;
      dispTime.Start();

    }
    private void dispTime_Tick(object sender, System.EventArgs e) {

      this.UnitsInStock = ran.Next(100, 150);
      dispTime.Interval = new TimeSpan(0, 0, 0, 0, ran.Next(20, 1500));

    }

  }
}
