﻿using System;
using System.Windows;
using System.Windows.Threading;
namespace Databinding.Notification {
  public class InventoryTickerC : DependencyObject {
    // change notification via a DependencyProperty

    #region DependencyProperty
    public int UnitsInStock {
      get { return (int)GetValue(UnitsInStockProperty); }
      set { SetValue(UnitsInStockProperty, value); }
    }

    public static readonly DependencyProperty UnitsInStockProperty =
        DependencyProperty.Register("UnitsInStock", typeof(int), typeof(InventoryTickerC), new UIPropertyMetadata(0));
    #endregion

    public String ProductName { get; set; }

    DispatcherTimer dispTime = new DispatcherTimer();
    static Random ran = new Random(DateTime.Now.Second);
    public InventoryTickerC() {
      dispTime.Interval = new TimeSpan(0, 0, 0, 0, ran.Next(20, 1500));
      dispTime.Tick += dispTime_Tick;
      dispTime.Start();

    }
    private void dispTime_Tick(object sender, System.EventArgs e) {

      this.UnitsInStock = ran.Next(100, 150);
      dispTime.Interval = new TimeSpan(0, 0, 0, 0, ran.Next(20, 1500));

    }
  }
}
