﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Windows;
using System.Windows.Controls;

namespace DataBindingMainApp {
  /// <summary>
  /// Interaction logic for ListOfDPs.xaml
  /// </summary>
  public partial class ListOfDPs : Page {
    public ListOfDPs() {
      InitializeComponent();
      this.Loaded += new RoutedEventHandler(ListOfDPs_Loaded);
      this.ElementsListBox.SelectionChanged += new SelectionChangedEventHandler(ElementsListBox_SelectionChanged);

    }

    void ElementsListBox_SelectionChanged(object sender, SelectionChangedEventArgs e) {
      Type t = (Type)ElementsListBox.SelectedItem;
      var q2 = from member
in t.GetFields
(BindingFlags.Public | BindingFlags.Static | BindingFlags.FlattenHierarchy)
               where member.FieldType == typeof(System.Windows.DependencyProperty)
               orderby member.Name
               select member;
      DpListBox.ItemsSource = q2.ToList<FieldInfo>();
      DpListBox.DisplayMemberPath = "Name";
    }

    void ListOfDPs_Loaded(object sender, RoutedEventArgs e) {
      string aName = "PresentationFramework, Version=3.0.0.0, Culture=neutral, PublicKeyToken= 31bf3856ad364e35";
      Assembly assembly = Assembly.Load(aName);
      var q = from type in assembly.GetTypes()
              where type.IsSubclassOf(typeof(System.Windows.FrameworkElement))
              orderby type.Name
              select type;

      ElementsListBox.ItemsSource = q.ToList();
      ElementsListBox.DisplayMemberPath = "Name";

      //var q1 = from member
      //in typeof(System.Windows.Controls.TextBlock).GetFields
      //(BindingFlags.Public | BindingFlags.Static | BindingFlags.FlattenHierarchy)
      //         where member.FieldType == typeof(System.Windows.DependencyProperty)
      //         orderby member.Name
      //         select member;

      var q2 = from member
      in typeof(System.Windows.Controls.TextBlock).GetFields
      (BindingFlags.Public | BindingFlags.Static | BindingFlags.FlattenHierarchy)
               where member.FieldType == typeof(System.Windows.DependencyProperty)
               orderby member.Name
               select member;
      DpListBox.ItemsSource = q2.ToList<FieldInfo>();
      DpListBox.DisplayMemberPath = "Name";

    }

    private void GetAllFields(ref List<FieldInfo> fields, Type type) {

    }
  }
}
