Imports Microsoft.VisualBasic
Imports System
Imports System.Windows.Data
Imports System.Windows.Media

Namespace DataBindingMainApp.DataConversion
  Friend Class AmountToBonusBrushConverter
	  Implements IValueConverter
	Private privateBonusGoal As Decimal
	Public Property BonusGoal() As Decimal
		Get
			Return privateBonusGoal
		End Get
		Set(ByVal value As Decimal)
			privateBonusGoal = value
		End Set
	End Property
	Private privateBonusBrush As Brush
	Public Property BonusBrush() As Brush
		Get
			Return privateBonusBrush
		End Get
		Set(ByVal value As Brush)
			privateBonusBrush = value
		End Set
	End Property
	Private privateDefaultBrush As Brush
	Public Property DefaultBrush() As Brush
		Get
			Return privateDefaultBrush
		End Get
		Set(ByVal value As Brush)
			privateDefaultBrush = value
		End Set
	End Property

	Public Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.Convert
	  ' the value param contains the original value
	  ' targetType specifies the type
	  ' data target binding that the current

	  Dim saleAmount As Decimal = CType(value, Decimal)
	  If saleAmount > BonusGoal Then
		Return BonusBrush
	  End If

	  Return DefaultBrush
	End Function

	Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack
	  ' not implemented
	  Throw New NotImplementedException("not implemented")
	End Function
  End Class
End Namespace
