Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel

Namespace Databinding.Local.DataSources
  Friend Class EmployeeWithValidation2
	  Implements IDataErrorInfo
	Private _errorDetails As Dictionary(Of String, String) = New Dictionary(Of String, String)()
	Private _errorString As String = String.Empty
	Private _firstName As String
	Public Property FirstName() As String
	  Get
		Return _firstName
	  End Get
	  Set(ByVal value As String)
		If String.IsNullOrEmpty(value) Then
		  _errorDetails("FirstName") = "You must provide a FirstName for the Employee."
		  _errorString = "Errors in Employee class."
		Else
		  _firstName = value
		  _errorDetails("FirstName") = ""
		  _errorString = ""
		End If
	  End Set
	End Property
	Private _lastName As String
	Public Property LastName() As String
	  Get
		Return _lastName
	  End Get
	  Set(ByVal value As String)
		If String.IsNullOrEmpty(value) Then
		  _errorDetails("LastName") = "You must provide a LastName for the Employee."
		  _errorString = "Errors in Employee class."

		Else
		  _lastName = value
		  _errorDetails("LastName") = ""
		  _errorString = ""
		End If
	  End Set
	End Property
	Private _salary As Decimal
	Public Property Salary() As Decimal
	  Get
		Return _salary

	  End Get
	  Set(ByVal value As Decimal)
		If value < 0 Then

		  _errorDetails("Salary") = "Salary cannot be less than zero."
		  _errorString = "Errors in Employee class."

		Else
		  _salary = value
		  _errorDetails("Salary") = ""
		  _errorString = ""
		End If
	  End Set
	End Property

	Private ReadOnly Property IDataErrorInfo_Error() As String Implements IDataErrorInfo.Error
	  Get
		Return _errorString
	  End Get
	End Property
	Public ReadOnly Property IDataErrorInfo_Item(ByVal propertyName As String) As String Implements IDataErrorInfo.Item
	  Get
		Return CStr(_errorDetails(propertyName))
	  End Get
	End Property
  End Class
End Namespace
