Imports Microsoft.VisualBasic
Imports System
Imports System.Reflection
Imports System.Windows
Imports System.Windows.Input
Imports System.Xml

Namespace DataBindingMainApp

  Partial Public Class MainWindow
	  Inherits Window
	Public Sub New()
	  InitializeComponent()
	  AddHandler Me.Loaded, AddressOf Window1_Loaded
	  AddHandler DemoTree.MouseUp, AddressOf This_MouseUp

	End Sub

	Private Sub Window1_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
	  Dim xe = TryCast(DemoTree.Items(0), XmlElement)
	  Dim xeMenu = TryCast(xe.ChildNodes(0), XmlElement)

	  Page = New Uri(xeMenu.GetAttribute("page"), UriKind.RelativeOrAbsolute)
	  OpenPage()
	End Sub

	Private Sub This_MouseUp(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
	  Dim xe = TryCast(DemoTree.SelectedItem, XmlElement)
	  If xe.Name <> "demo" Then
		Return

	  End If
	  Page = New Uri(xe.GetAttribute("page"), UriKind.RelativeOrAbsolute)
	  OpenPage()

	End Sub

	Public Sub OpenPage()
	  Dim folder = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetEntryAssembly().Location)
	  Dim file As String = folder & "\" & Page.ToString
	  If System.IO.File.Exists(file) Then

		ContentFrame.Source = Page

	  Else
		MessageBox.Show("Page not available.")
	  End If
	End Sub

	#Region "Properties"
	' Using a DependencyProperty as the backing store
	' for PageProperty.
	' This enables animation, styling, binding, etc...
	Public Shared ReadOnly PageProperty As DependencyProperty = DependencyProperty.Register("Page", GetType(Uri), GetType(MainWindow))

	Public Property Page() As Uri
	  Get
		  Return CType(GetValue(PageProperty), Uri)
	  End Get
	  Set(ByVal value As Uri)
		  SetValue(PageProperty, value)
	  End Set
	End Property
	#End Region
  End Class
End Namespace
